VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} MasterDlg 
   ClientHeight    =   5925
   ClientLeft      =   120
   ClientTop       =   465
   ClientWidth     =   5250
   OleObjectBlob   =   "MasterDlg.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "MasterDlg"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public bCanceled As Boolean

Private Sub UserForm_Initialize()
  bCanceled = True
  Me.StartUpPosition = visCenter
  UpdateState
End Sub

Public Property Get InputMode() As IOMode
' Get Input mode
  InputMode = MODE_EXCEL
  If btnInputOpt1.Value = True Then InputMode = MODE_WORD
  If btnInputOpt3.Value = True Then InputMode = MODE_VISIO
End Property

Public Property Get OutputMode() As IOMode
' Get output mode
  OutputMode = MODE_EXCEL
  If btnOutputOpt1.Value = True Then OutputMode = MODE_WORD
  If btnOutputOpt3.Value = True Then OutputMode = MODE_VISIO
End Property

Public Property Get InputLayout() As TLayout
  InputLayout = T_LAYOUT_RADIAL
  If btnModeX.Value = True Then InputLayout = T_LAYOUT_HORIZONTAL
  If btnModeY.Value = True Then InputLayout = T_LAYOUT_VERTICAL
End Property

Public Property Get AutoLayout() As Boolean
  AutoLayout = CheckBox1.Value
End Property

Public Property Get WordExportAsString() As Boolean
  WordExportAsString = CheckBox2.Value
End Property

Public Property Get XLExportAsTree() As Boolean
  XLExportAsTree = CBExcel.Value
End Property

Public Property Get InputFile() As String
  InputFile = textInput.Text
End Property

Private Sub btnInput_Click()
  If InputMode = MODE_VISIO Then
    Call UserInteraction.ShowMessage(EM_VISIO_INPUT)
    Exit Sub
  End If
  
  Dim sFile$: sFile = UserInteraction.PromptFile(ActiveDocument.Path, "  ", bNewApplication:=True)
  If sFile = vbNullString Then _
    Exit Sub
  
  textInput.Text = sFile
End Sub

Private Sub btnInputOpt1_Click()
  UpdateState
End Sub

Private Sub btnInputOpt2_Click()
  UpdateState
End Sub

Private Sub btnInputOpt3_Click()
  UpdateState
End Sub

Private Sub btnOutputOpt1_Click()
  UpdateState
End Sub

Private Sub btnOutputOpt2_Click()
  UpdateState
End Sub

Private Sub btnOutputOpt3_Click()
  UpdateState
End Sub

Private Function UpdateState()
  CheckBox2.Visible = btnOutputOpt1.Value
  CheckBox1.Visible = btnOutputOpt3.Value
  CBExcel.Visible = btnOutputOpt2.Value
  
  lblLevel.Visible = btnInputOpt3.Value
  btnModeX.Visible = btnInputOpt3.Value
  btnModeY.Visible = btnInputOpt3.Value
  btnModeRad.Visible = btnInputOpt3.Value
End Function

Private Sub UserForm_Activate()
  bCanceled = True
End Sub

Private Sub OkBtn_Click()
  bCanceled = False
  Me.Hide
End Sub

Private Sub CancelBtn_Click()
  bCanceled = True
  Me.Hide
End Sub


